import 'list_definition.dart';
import 'value.dart';

class ListDefinitionsOrigin {
  final _lists = <String, ListDefinition>{};
  final _allUnambiguousListValueCache = <String, ListValue>{};

  List<ListDefinition> get lists {
    var listOfLists = <ListDefinition>[];
    _lists.forEach((k, v) {
      listOfLists.add(v);
    });
    return listOfLists;
  }

  ListDefinitionsOrigin(List<ListDefinition> lists) {
    for (var list in lists) {
      _lists[list.name] = list;
      for (var itemWithValue in list.items.entries) {
        final item = itemWithValue.key;
        final val = itemWithValue.value;
        var listValue = ListValue.single(item, val);

        // May be ambiguous, but compiler should've caught that,
        // so we may be doing some replacement here, but that's okay.
        _allUnambiguousListValueCache[item.itemName!] = listValue;
        _allUnambiguousListValueCache[item.fullName] = listValue;
      }
    }
  }

  ListDefinition? getDefinition(String name) {
    return _lists[name];
  }

  ListValue? findSingleItemListWithName(String? name) {
    return _allUnambiguousListValueCache[name];
  }

  /*
  static ListDefinitionsOrigin fromJson(Map<String, dynamic> json) {
    var allDefs = <ListDefinition>[];
    json.forEach((key, value) {
      var name = key;
      var listDefJson = Map<String, dynamic>.from(value);

      // Cast (string, object) to (string, int) for items
      var items = <String, int>{};
      listDefJson.forEach((key, value) {
        items[key] = value as int;
      });

      var def = ListDefinition(name, items);
      allDefs.add(def);
    });
    return ListDefinitionsOrigin(allDefs);
  }*/
}
