/// <summary>
/// Exception that represents an error when running a Story at runtime.
/// An exception being thrown of this type is typically when there's
/// a bug in your ink, rather than in the ink engine itself!
/// </summary>
class StoryException implements Exception {
  bool useEndLineNumber = false;
  final String? message;

  StoryException([this.message]);

  @override
  String toString() {
    Object? message = this.message;
    if (message == null) return "Exception";
    return "StoryException: $message";
  }
}
