import 'package:meta/meta.dart';

import 'runtime_object.dart';

/// The value to be assigned is popped off the evaluation stack, so no need to keep it here
class VariableAssignment extends RuntimeObject {
  String? _variableName;
  bool _isNewDeclaration = false;
  bool isGlobal = false;

  VariableAssignment([this._variableName, this._isNewDeclaration = false]);

  @override
  String toString() {
    return 'VarAssign to $variableName';
  }

  @protected
  set variableName(value) => _variableName = value;

  String? get variableName => _variableName;

  @protected
  set isNewDeclaration(value) => _isNewDeclaration = value;

  bool get isNewDeclaration => _isNewDeclaration;
}
