import 'package:ink_runtime/ink.dart';
import 'package:logging/logging.dart';
import 'package:test/test.dart';

import 'test_utils.dart';

void main() {
  Logger.root.level = Level.FINE;
  Logger.root.onRecord.listen((record) {
    print(
        '${record.level.name}: ${record.time}: ${record.loggerName}: ${record.message}');
  });
  group('Basic Text', () {
    setUp(() {});

    test('One Line', () {
      var text = <String>[];
      var json = getJsonString('basictext/oneline.ink.json');
      var story = Story.fromJson(json);
      nextAll(story, text);
      expect(text.length, 1);
      expect(text.first, 'Line.');
    });

    test('Two Lines', () {
      var text = <String>[];
      var json = getJsonString('basictext/twolines.ink.json');
      var story = Story.fromJson(json);
      nextAll(story, text);
      //print(story.Continue());
      //print(story.Continue());
      expect(text, hasLength(2));
      expect(text.first, 'Line.');
      expect(text[1], 'Other line.');
    });

    test('container Line', () {
      var text = <String>[];
      var json = getJsonString('basictext/oneline.ink.json');
      var story = Story.fromJson(json);
      nextAll(story, text);
      expect(text.length, 1);
      expect(text.first, 'Line.');
    });
  });
}
