import 'package:ink_runtime/ink.dart';
import 'package:logging/logging.dart';
import 'package:test/test.dart';

import 'test_utils.dart';

void main() {
  logSetUp();
  group('Glue Spec', () {
    late Story story;

    setUp(() {});
    tearDown(() {
      story.resetState();
    });
    test('simpleGlue - bind text together across multiple lines of text', () {
      story = loadStory('glue/simple-glue.ink.json');
      var text = <String>[];

      nextAll(story, text);
      expect(text.length, 1);
      expect(text[0], "Some content with glue.");
    });

    test('glueWithDivert - bind text together across multiple lines of text',
        () {
      story = loadStory('glue/glue-with-divert.ink.json');
      var text = <String>[];

      nextAll(story, text);
      expect(text.length, 1);
      expect(text[0], "We hurried home to Savile Row as fast as we could.");
    });

    test(
        'testLeftRightGlueMatching - - bind text together across multiple lines of text',
        () {
      story = loadStory('glue/left-right-glue-matching.ink.json');
      var text = <String>[];

      nextAll(story, text);
      expect(text.length, 2);
      expect(text[0], "A line.");
      expect(text[1], "Another line.");
    });

    test('text bug fix1 - bind text together across multiple lines of text',
        () {
      story = loadStory('glue/testbugfix1.ink.json');
      var text = <String>[];

      nextAll(story, text);

      expect(text.length, 2);
      expect(text[0], "A");
      expect(text[1], "C");
    });

    test('text bug fix2 - bind text together across multiple lines of text',
        () {
      story = loadStory('glue/testbugfix2.ink.json');
      var text = <String>[];

      nextAll(story, text);

      expect(text.length, 2);
      // Assert.assertEquals("A ", text.get(0)); // TODO nextAll is trimming!
      expect(text[1], "X");
    });
  });
}
