
import 'package:ink_runtime/ink.dart';
import 'package:test/test.dart';

void main() {
  group('Path - tests', () {
    test('TestPaths', () {
      // Different instances should ensure different instances of individual components
      var path1 = Path('hello.1.world');
      var path2 = Path('hello.1.world');

      var path3 = Path('.hello.1.world');
      var path4 = Path('.hello.1.world');

      var path5 = Path('hello.1.world');
      expect(path1, equals(path2));
      expect(path3, equals(path4));
      expect(path1, isNot(equals(path3)));
      expect(path4, isNot(equals(path5)));
    });

    test('Test get componentsString', () {
      final string = '0.1.world';
      var path1 = Path(string);
      print(path1.toString());
      expect(path1.componentsString, equals(string));
      expect(path1.isRelative, false);

      final string2 = '.hello.1.world';
      var path2 = Path(string2);
      expect(path2.isRelative, isTrue);
      expect(path2.componentsString, equals(string2.substring(1)));
    });
  });
}
