import 'dart:convert';

import 'package:test/test.dart';

import '../../runtime_tests.dart';
import 'inkfiles/compiled/bindings/external_binding.ink.json.dart'
    as external_binding;

void main() {
  group('Bindings', () {
    test('tests external bindings', () async {
      var story = await createStory(jsonEncode(external_binding.json));

      var testExternalBindingMessage = '';

      story.BindExternalFunction1('message', (s) {
        testExternalBindingMessage = 'MESSAGE: $s';
        return '';
      });
      story.BindExternalFunction2('multiply', (arg1, arg2) {
        return (arg1 as num) * (arg2 as num);
      });
      story.BindExternalFunction2('times', (numberOfTimes, stringValue) {
        var result = '';
        for (var i = 0; i < (numberOfTimes as int); i++) {
          result += stringValue as String;
        }
        return result;
      });
      expect(story.Continue(), '15.0\n');
      expect(story.Continue(), 'knock knock knock\n');
      expect(testExternalBindingMessage, 'MESSAGE: hello world');
    });
    /*
    it('tests game ink back and forth', () async {
      var story = await createStory('game_ink_back_and_forth');

      story.BindExternalFunction1('gameInc', (num x) {
        x += 1;
        x = story.EvaluateFunction('inkInc', [x]).returned;
        return x;
      });

      var finalResult = story.EvaluateFunction('topExternal', [5]);

      expect(finalResult.returned, 7);
      expect(finalResult.output, 'In top external\n');
    });*/

    /*
    it("tests variable observer", () async {
    var story = await createStory("variable_observer");

    var currentVarValue = 0;
    var observerCallCount = 0;

    story.ObserveVariable("testVar", (varName: any, newValue: any) async {
    currentVarValue = newValue;
    observerCallCount += 1;
    });

    story.ContinueMaximally();

    expect(currentVarValue,15);
    expect(observerCallCount,1);

    story.ChooseChoiceIndex(0);
    story.Continue();

    expect(currentVarValue,25);
    expect(observerCallCount,2);
    });

    it("tests lookup safe or not", () async {
    // SAFE Lookahead
    var story = await createStory("lookup_safe_or_not");

    var callCount = 0;
    story.BindExternalFunction(
    "myAction",
    () async {
    callCount++;
    },
    true
    );

    story.ContinueMaximally();
    expect(callCount,2);

    // UNSAFE Lookahead
    callCount = 0;
    story.ResetState();
    story.UnbindExternalFunction("myAction");
    story.BindExternalFunction(
    "myAction",
    () async {
    callCount++;
    },
    false
    );

    story.ContinueMaximally();
    expect(callCount,1);

    // SAFE Lookahead with glue broken intentionally
    var story = await createStory("lookup_safe_or_not_with_post_glue");

    // Disabling this rule to match the tests from upstream.
    // eslint-disable-next-line @typescript-eslint/no-empty-function
    story.BindExternalFunction("myAction", () async {});
    var result = story.ContinueMaximally();
    expect(result,"One\nTwo\n");
    });*/
  });
}
