import 'dart:convert';

import 'package:ink_runtime/ink.dart';
import 'package:test/test.dart';

import '../../runtime_tests.dart';
import 'inkfiles/compiled/conditions/all_switch_branches_fail_is_clean.ink.json.dart'
    as all_switch_branches_fail_is_clean;
import 'inkfiles/compiled/conditions/else_branches.ink.json.dart'
    as else_branches;
import 'inkfiles/compiled/conditions/empty_multiline_conditional_branch.ink.json.dart'
    as empty_multiline_conditional_branch;
import 'inkfiles/compiled/conditions/trivial_condition.ink.json.dart'
    as trivial_condition;

void main() {
  group('Conditions', () {
    test('tests all switch branches fail is clean', () async {
      var story =
          await createStory(jsonEncode(all_switch_branches_fail_is_clean.json));

      story.Continue();
      expect(story.state.evaluationStack.length, 0);
    });

    test('tests else branches', () async {
      var story = await createStory(jsonEncode(else_branches.json));

      expect(story.ContinueMaximally(), 'other\nother\nother\nother\n');
    });

    test('tests empty multiline conditional branch', () async {
      var story = await createStory(
          jsonEncode(empty_multiline_conditional_branch.json));

      expect(story.Continue(), '');
    });

    test('tests trivial condition', () async {
      var story = await createStory(jsonEncode(trivial_condition.json));

      story.Continue();
      expect(story.hasError, false);
    });
  });
}
