import 'dart:convert';

import 'package:ink_runtime/ink.dart';
import 'package:test/test.dart';

import '../../../runtime_tests.dart';
import '../inkfiles/compiled/inkjs/tests.ink.json.dart' as $tests;

void main() {
  group('Inkjs', () {
    group('Divert', () {
      late Story story;

      setUp(() async {
        story = await createStory(jsonEncode($tests.json));
      });
      test('should divert to a knot', () {
        story.ChoosePathString('divert.divert_knot');

        expect(story.Continue(), 'Diverted to a knot\n');
      });

      test('should divert to a stitch', () {
        story.ChoosePathString('divert.divert_stitch');

        expect(story.Continue(), 'Diverted to a stitch\n');
      });

      test('should divert to an internal stitch', () {
        story.ChoosePathString('divert.internal_stitch');

        expect(story.Continue(), 'Diverted to internal stitch\n');
      });

      test('should divert with a variable', () {
        story.ChoosePathString('divert.divert_var');

        expect(story.Continue(), 'Diverted with a variable\n');
      });
    });
  });
}
