import 'dart:convert';

import 'package:ink_runtime/ink.dart';
import 'package:test/test.dart';

import '../../../runtime_tests.dart';
import '../inkfiles/compiled/inkjs/tests.ink.json.dart' as $tests;

void main() {
  group('Inkjs', () {
    group('Flows', () {
      late Story story;

      setUp(() async {
        story = await createStory(jsonEncode($tests.json));
      });
      test('should go through a tunnel', () {
        story.ChoosePathString('flow_control.tunnel_call');
        expect(story.Continue(), 'tunnel end\n');
        expect(story.canContinue, false);
      });

      test('should follow threads', () {
        story.ChoosePathString('flow_control.thread');
        expect(story.Continue(), 'thread start\n');
        expect(story.Continue(), 'threaded text\n');
        expect(story.Continue(), 'thread end\n');

        expect(story.canContinue, false);
        expect(story.currentChoices.length, 2);
        expect(story.currentChoices[0].text, 'first threaded choice');
        expect(story.currentChoices[1].text, 'second threaded choice');

        story.ChooseChoiceIndex(0);
        expect(story.Continue(), 'first threaded choice\n');
        expect(story.canContinue, false);
      });
    });
  });
}
