import 'dart:convert';

import 'package:test/test.dart';

import '../../runtime_tests.dart';
import 'inkfiles/compiled/multiflow/multi_flow_basics.ink.json.dart'
    as multi_flow_basics;

void main() {
  group('MultiFlow', () {
    test('tests external bindings', () async {
      var story = await createStory(jsonEncode(multi_flow_basics.json));

      story.SwitchFlow('First');
      story.ChoosePathString('knot1');
      expect(story.Continue(), 'knot 1 line 1\n');

      story.SwitchFlow('Second');
      story.ChoosePathString('knot2');
      expect(story.Continue(), 'knot 2 line 1\n');

      story.SwitchFlow('First');
      expect(story.Continue(), 'knot 1 line 2\n');

      story.SwitchFlow('Second');
      expect(story.Continue(), 'knot 2 line 2\n');
    });
  });
}
