import 'dart:io';

import 'package:http/http.dart' as http;
import 'package:ink_runtime/ink.dart';
import 'package:logging/logging.dart';
import 'package:test/test.dart';

String getJsonString(String fileName) {
  return File('test/fixtures/$fileName').readAsStringSync();
}

var client = http.Client();

Future<String> loadFromUrl(String jsonUrl) {
  var url = Uri.parse(jsonUrl);

  return client.get(url).then((value) => value.body);
}
/*
List<String> runStory(
    String fileName, List<int>? choiceList, List<String> errors) {
  // 1) Load story
  var json = getJsonString(fileName);

//		System.out.println(json);

  var story = Story.fromJson(json);
  Story story ;

  var text = <String>[];

//		System.out.println(story.BuildStringOfHierarchy());

  var choiceListIndex = 0;

  while (story.canContinue || story.currentChoices.isNotEmpty) {
    // 2) Game content, line by line
    while (story.canContinue) {
      var line = story.Continue();
      print(line);
      text.add(line!);
    }

    if (story.hasError) {
      for (var errorMsg in story.currentErrors!) {
        print(errorMsg);
        errors.add(errorMsg);
      }
    }

    // 3) Display story.currentChoices list, allow player to choose one
    if (story.currentChoices.isNotEmpty) {
      for (var c in story.currentChoices) {
        print(c.text);
        text.add(c.text + '\n');
      }

      if (choiceList == null || choiceListIndex >= choiceList.length) {
        story.chooseChoiceIndex(Random().nextInt(story.currentChoices.length));
      } else {
        story.chooseChoiceIndex(choiceList[choiceListIndex]);
        choiceListIndex++;
      }
    }
  }

  return text;
}*/

bool isEnded(Story story) {
  return !story.canContinue && story.currentChoices.isEmpty;
}

List<String> nextAll(Story story, List<String> text) {
  var c = 1;
  while (story.canContinue) {
    print('canContinue : ${c++}');
    var line = story.Continue();

    print('line: $line');

    if (line != null) {
      text.add(line.trim());
    }
  }

  if (story.hasError) {
    fail(story.currentErrors!.join());
  }
  return text;
}

void logSetUp() {
  Logger.root.level = Level.ALL;
  Logger.root.onRecord.listen((event) {
    print('[${event.loggerName}] - ${event.message}');
  });
}
