import 'package:ink_runtime/ink.dart';
import 'package:test/test.dart';

import 'test_utils.dart';

void main() {
  group('Story State', () {
    setUp(() {});

    test('trySplittingHeadTailWhitespace Test', () {
      var value = StringValue('\nLine. ');
      var json = getJsonString('basictext/oneline.ink.json');

      var list = StoryState(Story.fromJson(json))
          .trySplittingHeadTailWhitespace(value);
      print(list);
      expect(list, isNotNull);
      expect(list!.isNotEmpty, isTrue);
    });

    test('cleanOutputWhitespace Test', () {
      var json = getJsonString('basictext/oneline.ink.json');

      var text =
          StoryState(Story.fromJson(json)).cleanOutputWhitespace('Test ');
      print(text);
      expect(text.length, 4);
    });

    test('save divert', () {
      var json = getJsonString('variable/var-divert.ink.json');
      var story = Story.fromJson(json);
      VariablesState.dontSaveDefaultValues = false;

      var saved = story.state.ToJson();
      print(saved);

      story.state.LoadJson(saved);
      saved = story.state.ToJson();
      print(saved);
      VariablesState.dontSaveDefaultValues = true;

      //state.variablesState['testDivert'] = DivertTargetValue('1');
    });
  });
}
